import React, { Component } from 'react';
import clone from 'clone';
import { FieldsComponent } from './index';
import { termKeyNames } from '../../helper';

export default class RowComponent extends Component {
  render() {
    const { dragItem, editField, deleteField, selectedField } = this.props;
    let clicked = false;
    const onFieldClick = () => {
      if (!clicked) {
        editField(dragItem);
      }
    };
    const handleDelete = () => {
      clicked = true;
      deleteField(dragItem);
    };
    let bundleItem = '';
    if (dragItem.type === 'set') {
      const rowComponentOptions = {
        ...this.props,
        allRows: clone(dragItem.rows),
        parentId: dragItem.id,
      };
      bundleItem = (<div className="scwpFormAddFieldsBundle" style={{ marginLeft: '10px' }}>
        <FieldsComponent {...rowComponentOptions} />
      </div>);
    }
    const isSelected = selectedField && selectedField.id === dragItem.id;
    const title = dragItem.title ? dragItem.title
      : (termKeyNames[dragItem.id] ? termKeyNames[dragItem.id] : dragItem.id);
    return (<div className="scwpFormFieldsNameDel">
      <span className="scwpFormFieldsName" style={{ background: isSelected ? '#d1d1d1' : '#ffffff' }} onClick={onFieldClick}>{title}</span>
      <button type="button" onClick={handleDelete} className="scwpDeleteFieldsBtn" />
      {bundleItem}
    </div>);
  }
}
