const selectedPost = {
  id: 'selectedPost',
  type: 'comboselect',
  label: 'Select Post',
  value: '',
};
const titleSet = {
  id: 'title',
  type: 'text',
  label: 'Enter Title',
  value: '',
};
const title = {
  id: 'title',
  type: 'text',
  label: 'Enter Custom Title',
  placeholder: 'Default type',
  value: '',
};
const height = {
  id: 'height',
  type: 'text',
  label: 'Enter Custom Height',
  placeholder: 'Enter a custom height for each row',
  value: '55px',
};
const displayType = {
  id: 'displayType',
  type: 'radio',
  label: 'Choose display type',
  value: 'simple',
  options: {
    simple: 'Simple',
    rating: 'Rating',
    boolean: 'Boolean',
    price: 'WooCommerce Price',
    hyperlink: 'Hiperlink',
  },
};
const customScrollbar = {
  id: 'customScrollbar',
  type: 'radio',
  label: 'Enable custom scrollbar',
  value: 'disable',
  options: {
    enable: 'Enable',
    disable: 'Disable',
  },
};
const linkUrl = {
  id: 'linkUrl',
  label: 'Enter the link url',
  type: 'text',
  subtitle: '',
  placeholder: '',
  delimiter: '',
};
const hyperLinkUrl = {
  id: 'hyperLinkUrl',
  label: 'Enter the hyper link referral url',
  type: 'text',
  subtitle: '',
  placeholder: '',
  delimiter: '',
};
const hyperLinkText = {
  id: 'hyperLinkText',
  label: 'Enter button text to show',
  type: 'text',
  subtitle: '',
  placeholder: '',
  delimiter: '',
};
const hyperLinkClass = {
  id: 'hyperLinkClass',
  label: 'Enter link button class to add',
  type: 'text',
  subtitle: '',
  placeholder: '',
  delimiter: '',
};
const hyperLinkTarget = {
  id: 'hyperLinkTarget',
  label: 'Enter Target',
  type: 'radio',
  subtitle: '',
  options: {
    _self: 'Self',
    _blank: 'Blank',
  },
  value: '_blank',
};
// const customId = {
//   id: 'customId',
//   type: 'text',
//   label: 'Enter Custom Id',
//   placeholder: 'if custom class is chosen',
//   value: '',
// };
// const topHeader = {
//   id: 'topHeader',
//   type: 'switchalt',
//   label: 'Is it top header ?',
//   value: 'false',
// };

const groupBy = {
  id: 'groupBy',
  type: 'switchalt',
  label: 'Header Group',
  value: 'false',
};

const configRow = [
  selectedPost,
  title,
  height,
  displayType,
  customScrollbar,
  linkUrl,
  hyperLinkUrl,
  hyperLinkText,
  hyperLinkClass,
  hyperLinkTarget,
];
// const configRow = [selectedPost, title, displayType, customId];
const configSet = [titleSet, groupBy];
const initConfigRow = {};
configRow.forEach((row) => {
  initConfigRow[row.id] = row.value;
});
const conditions = [
  {
    logicBlock: [
      {
        key: 'field',
        value: {
          fieldID: 'displayType',
          secondOperand: {
            type: 'value',
            value: ' ',
          },
          operator: 'not_equal_to',
        },
        childresult: true,
      },
    ],
    effectField: [
      {
        action: 'hide',
        fieldID: 'linkUrl',
      },
      {
        action: 'hide',
        fieldID: 'hyperLinkUrl',
      },
      {
        action: 'hide',
        fieldID: 'hyperLinkText',
      },
      {
        action: 'hide',
        fieldID: 'hyperLinkClass',
      },
      {
        action: 'hide',
        fieldID: 'hyperLinkTarget',
      },
    ],
  },
  {
    logicBlock: [
      {
        key: 'field',
        value: {
          fieldID: 'displayType',
          secondOperand: {
            type: 'value',
            value: 'hyperlink',
          },
          operator: 'equal_to',
        },
        childresult: true,
      },
    ],
    effectField: [
      {
        action: 'show',
        fieldID: 'hyperLinkUrl',
      },
      {
        action: 'show',
        fieldID: 'hyperLinkText',
      },
      {
        action: 'show',
        fieldID: 'hyperLinkClass',
      },
      {
        action: 'show',
        fieldID: 'hyperLinkTarget',
      },
    ],
  },];
export { configRow, configSet, initConfigRow, conditions };
