import React, { Component } from 'react';
import Modal from 'react-modal';
import swal from 'sweetalert';
import {  prettifyCamelCase } from '../helper';

const ReuseForm = __REUSEFORM__;

export default class addPostModal extends Component {
  render() {
    const { modalIsOpen, closeModal, addPostType, postTypes } = this.props;
    let selectedPost;
    const customStyles = {
      content: {
        top: '50%',
        left: '50%',
        right: 'auto',
        bottom: 'auto',
        marginRight: '-50%',
        width: '700px',
        minHeight: '300px',
        transform: 'translate(-50%, -50%)',
      },
    };
    const options = {};
    ALIKE_ADMIN.helper.all_post_types.forEach((type) => {
      if (postTypes.findIndex(post => post === type) === -1) {
        options[type] = prettifyCamelCase(type);
      }
    });
    const reuseOption = {
      reuseFormId: 'addPost',
      fields: [{
        id: 'selectedPost',
        type: 'select',
        label: 'Select Post Types',
        multiple: 'false',
        options,
      }],
      getUpdatedFields: (data) => { selectedPost = data.selectedPost; },
      preValue: { selectedPost: '' },
      errorMessages: {},
    };
    const addAction = () => {
      if (selectedPost) {
        addPostType(selectedPost);
      } else {
        swal('error!', 'select a post types.', 'error');
      }
    };
    return (<Modal
      isOpen={modalIsOpen}
      onRequestClose={closeModal}
      style={customStyles}
      contentLabel={'contentLabel'}
    >
      <ReuseForm {...reuseOption} />
      <div className='modalButtonWrapper'>
        <button onClick={addAction}>Add</button>
        <button onClick={closeModal}>cancel</button>
      </div>
    </Modal>);
  }
}
