const $ = jQuery;
import { findIndex } from "underscore";

$(".alikeMobileDrawerJs").on("click", function (e) {
	e.preventDefault();
	$("body").toggleClass("alikeDrawerToggle");
});

$(".alikeCloseDrawer").on("click", function (e) {
	$("body").removeClass("alikeDrawerToggle");
});
// $('.alike-group-content').parent().css('background', 'white');
$(".alike-group-content").parent().css("border-right", 0);

$(".alike-compare-widget-wrapper")
	.mouseenter(function () {
		$(".alike-compare-widget-content")
			.removeClass("alike-compare-widget-content-before-scale")
			.addClass("alike-compare-widget-content-scale");
	})
	.mouseleave(function () {
		$(".alike-compare-widget-content")
			.removeClass("alike-compare-widget-content-scale")
			.addClass("alike-compare-widget-content-before-scale");
	});

$(document).on("click", function (e) {
	var alikeBtnAndWrapper = $("a.alike-button");

	if (
		!alikeBtnAndWrapper.is(e.target) &&
		alikeBtnAndWrapper.has(e.target).length === 0
	) {
		$(".alike-compare-widget-content")
			.removeClass("alike-compare-widget-content-scale")
			.addClass("alike-compare-widget-content-before-scale");
	}
});

$("body").on("click", "a.alike-button", function (e) {
	e.preventDefault();
	const postId = $(this).data("post-id");
	const postTitle = $(this).data("post-title");
	const postThumb = $(this).data("post-thumb");
	const postLink = $(this).data("post-link");

	const allPosts = window.localStorage.getItem("alikeData")
		? JSON.parse(window.localStorage.getItem("alikeData"))
		: [];

	const checkIndex = findIndex(allPosts, { postId });

	if (checkIndex === -1) {
		const newPost = {
			postId,
			postTitle,
			postThumb,
			postLink,
		};
		if (allPosts.length < ALIKE.max_compare) {
			allPosts.push(newPost);
		} else {
			alert(ALIKE.LANG.YOU_CAN_COMPARE_MAXIMUM_BETWEEN_S_ITEMS);
		}
	}

	window.localStorage.setItem("alikeData", JSON.stringify(allPosts));

	if (ALIKE.CHECK_DEVICE == "yes") {
		$("body").toggleClass("alikeDrawerToggle");
		onStorageEventMobile();
	} else {
		$("alike-compare-widget-wrapper").show();
		$(".alike-compare-widget-content")
			.removeClass("alike-compare-widget-content-before-scale")
			.addClass("alike-compare-widget-content-scale");
		onStorageEvent();
	}
});

function widgetPostRemove() {
	$(document).ready(function () {
		// Remove item icon click
		$("body").on(
			"click",
			"span.alike-compare-widget-post-remove-button",
			function (e) {
				e.preventDefault();
				const postId = $(e.target).data("post-id");
				const allPosts = JSON.parse(window.localStorage.getItem("alikeData"));
				const checkIndex = findIndex(allPosts, { postId });

				if (checkIndex !== -1) {
					allPosts.splice(checkIndex, 1);
					window.localStorage.setItem("alikeData", JSON.stringify(allPosts));

					onStorageEvent();
				}
			}
		);

		// Remove all button click
		$("body").on(
			"click",
			".alike-compare-widget-post-remove-all-content",
			function (e) {
				e.preventDefault();
				window.localStorage.setItem("alikeData", "[]");
				onStorageEvent();
			}
		);

		// Mobile remove item close icon click
		$("body").on("click", "a.alike-close-item", function (e) {
			e.preventDefault();
			const postId = $(e.target).data("post-id");
			const allPosts = JSON.parse(window.localStorage.getItem("alikeData"));
			const checkIndex = findIndex(allPosts, { postId });

			if (checkIndex !== -1) {
				allPosts.splice(checkIndex, 1);
				window.localStorage.setItem("alikeData", JSON.stringify(allPosts));
				if (allPosts.length == 0) {
					$("body").removeClass("alikeDrawerToggle");
				}
				onStorageEventMobile();
			}
		});

		// Mobile Remove All button click
		$("body").on("click", ".alike-btn-remove-all", function (e) {
			e.preventDefault();
			window.localStorage.setItem("alikeData", "[]");
			$("body").removeClass("alikeDrawerToggle");
			onStorageEventMobile();
		});
	});
}

$(window).on("load", function () {
	const items =
		JSON.parse(localStorage.getItem("alikeData")) !== null
			? JSON.parse(localStorage.getItem("alikeData"))
			: [];
	$(".alike-compare-widget-counter").html(items.length);
	if (items.length > 0) {
		$(".alike-compare-widget-wrapper").show();
		var customWidth = items.length * 160;
		$(".alike-compare-widget-content").css("width", customWidth + "px");
		// $('.alike-compare-widget-content').removeClass('alike-compare-widget-content-before-scale').addClass('alike-compare-widget-content-scale');
	} else {
		$(".alike-compare-widget-wrapper").hide();
	}
	if (ALIKE.CHECK_DEVICE == "yes") {
		$("body").removeClass("alikeDrawerToggle");
		onStorageEventMobile();
	} else {
		onStorageEvent();
	}
});

function onStorageEvent(storageEvent) {
	if ($(".alike-compare-widget-content-load").length > 0) {
		const items =
			JSON.parse(localStorage.getItem("alikeData")) !== null
				? JSON.parse(localStorage.getItem("alikeData"))
				: [];
		$(".alike-compare-widget-counter").html(items.length);
		if (items.length > 0) {
			$(".alike-compare-widget-wrapper").show();
			var customWidth = items.length * 160;
			$(".alike-compare-widget-content").css("width", customWidth + "px");
			// $('.alike-compare-widget-content').removeClass('alike-compare-widget-content-before-scale').addClass('alike-compare-widget-content-scale');
		} else {
			$(".alike-compare-widget-wrapper").hide();
		}

		const resultTemplate = _.template($(".alike-list").html());
		const resultingHtml = resultTemplate({ items });
		const allPostIds = [];
		items.forEach(function (value) {
			allPostIds.push(value.postId);
		});

		const pageUrl = ALIKE.pageUrl;
		$(".alike-compare-widget-button").attr(
			"href",
			pageUrl + "?ids=" + allPostIds.join([","])
		);

		$(".alike-compare-widget-content-load").html(resultingHtml);
		widgetPostRemove();
	}
}

function onStorageEventMobile(storageEvent) {
	if ($(".alike-compare-widget-mobile-content-load").length > 0) {
		const items =
			JSON.parse(localStorage.getItem("alikeData")) !== null
				? JSON.parse(localStorage.getItem("alikeData"))
				: [];
		$(".alike-compare-widget-counter").html(items.length);
		if (items.length > 0) {
			$(".alike-compare-widget-wrapper").show();
		} else {
			$(".alike-compare-widget-wrapper").hide();
		}
		const resultTemplateMobile = _.template($(".alike-mobile-list").html());
		const resultingHtmlMobile = resultTemplateMobile({ items });

		const allMobilePostIds = [];
		items.forEach(function (value) {
			allMobilePostIds.push(value.postId);
		});
		const pageUrlMobile = ALIKE.pageUrl;
		$(".alike-btn-compare").attr(
			"href",
			pageUrlMobile + "?ids=" + allMobilePostIds.join([","])
		);

		$(".alike-compare-widget-mobile-content-load").html(resultingHtmlMobile);
		widgetPostRemove();
	}
}

window.loadAlike = onStorageEvent;
window.loadAlikeMobile = onStorageEventMobile;

window.addEventListener("storage", onStorageEvent, false);
window.addEventListener("storage", onStorageEventMobile, false);

$(window).on("load", function () {
	$(".rq-alike-custom-scrollbar").mCustomScrollbar({
		autoExpandScrollbar: true,
		alwaysShowScrollbar: 0,
		autoHideScrollbar: false,
	});
	$(".rq-alike-topic").mCustomScrollbar({
		autoExpandScrollbar: true,
	});
});
