const { watch, src, series , dest} = require('gulp');
const gulp = require("gulp");
const webpack = require('webpack-stream');
const sass = require('gulp-sass')(require('sass'));
var rename = require('gulp-rename');
const cleanCSS = require("gulp-clean-css");
const autoprefixer = require('gulp-autoprefixer');

const paths = {
    style: {
        src : ['assets/src/scss/**/*.scss'],
        dest: 'assets/dist/css'
    },
    images: {
        src : 'assets/img/**/*.{jpg,jpeg,png,svg,gif}',
        dest: 'assets/img'
    },
    package: {
        src : ['**/*', '!node_modules{,/**}', '!src{,/**}', '!packaged{,/**}'],
        dest: './package'
    }
};

function admin_script() {
    return gulp
    .src('./assets/src/updated_backed/admin.js')
    .pipe(
      webpack({
        watch: true,
        externals: {
            jquery: 'jQuery',
          },
        // Any configuration options...
      })
    )
    .pipe(rename('admin.min.js'))
    .pipe(gulp.dest('assets/dist/js/'));
};
exports.admin_script = admin_script;

function style() {
    return gulp.src(paths.style.src)
        .pipe(sass().on('error', sass.logError))
        .pipe(autoprefixer({cascade: false}))
        .pipe(cleanCSS({compatibility: 'ie8'}))
        .pipe(rename({ extname: '.min.css' }))
        .pipe(gulp.dest(paths.style.dest))
};

exports.style = style;


function watchTask () {
    watch(paths.style.src, style);
}

exports.default = series(style, watchTask);